package com.fuyuanshen.equipment.service.impl;

import com.fuyuanshen.common.core.utils.MapstructUtils;
import com.fuyuanshen.common.mybatis.core.page.TableDataInfo;
import com.fuyuanshen.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.fuyuanshen.equipment.domain.DeviceFenceAccessRecord;
import com.fuyuanshen.equipment.domain.bo.DeviceFenceAccessRecordBo;
import com.fuyuanshen.equipment.domain.vo.DeviceFenceAccessRecordVo;
import com.fuyuanshen.equipment.mapper.DeviceFenceAccessRecordMapper;
import com.fuyuanshen.equipment.service.IDeviceFenceAccessRecordService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 围栏进出记录Service业务层处理
 *
 * @author Lion Li
 * @date 2025-09-11
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class DeviceFenceAccessRecordServiceImpl implements IDeviceFenceAccessRecordService {

    private final DeviceFenceAccessRecordMapper baseMapper;


    /**
     * 查询围栏进出记录
     *
     * @param id 主键
     * @return 围栏进出记录
     */
    @Override
    public DeviceFenceAccessRecordVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询围栏进出记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 围栏进出记录分页列表
     */
    @Override
    public TableDataInfo<DeviceFenceAccessRecordVo> queryPageList(DeviceFenceAccessRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DeviceFenceAccessRecord> lqw = buildQueryWrapper(bo);
        // Page<DeviceFenceAccessRecordVo> result = baseMapper.selectVoPageWithFenceAndDeviceName(pageQuery.build(), lqw);
        Page<DeviceFenceAccessRecordVo> result = baseMapper.selectVoPageByXml(pageQuery.build(), bo);
        return TableDataInfo.build(result);
    }


    /**
     * 查询符合条件的围栏进出记录列表
     *
     * @param bo 查询条件
     * @return 围栏进出记录列表
     */
    @Override
    public List<DeviceFenceAccessRecordVo> queryList(DeviceFenceAccessRecordBo bo) {
        // LambdaQueryWrapper<DeviceFenceAccessRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoPageByXml(bo);
    }


    private LambdaQueryWrapper<DeviceFenceAccessRecord> buildQueryWrapper(DeviceFenceAccessRecordBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DeviceFenceAccessRecord> lqw = Wrappers.lambdaQuery();
        // lqw.orderByAsc(DeviceFenceAccessRecord::getId);
        lqw.eq(bo.getFenceId() != null, DeviceFenceAccessRecord::getFenceId, bo.getFenceId());
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceId()), DeviceFenceAccessRecord::getDeviceId, bo.getDeviceId());
        lqw.eq(bo.getUserId() != null, DeviceFenceAccessRecord::getUserId, bo.getUserId());
        lqw.eq(bo.getEventType() != null, DeviceFenceAccessRecord::getEventType, bo.getEventType());
        lqw.eq(bo.getLatitude() != null, DeviceFenceAccessRecord::getLatitude, bo.getLatitude());
        lqw.eq(bo.getLongitude() != null, DeviceFenceAccessRecord::getLongitude, bo.getLongitude());
        lqw.eq(bo.getAccuracy() != null, DeviceFenceAccessRecord::getAccuracy, bo.getAccuracy());
        lqw.eq(bo.getEventTime() != null, DeviceFenceAccessRecord::getEventTime, bo.getEventTime());
        lqw.eq(bo.getCreateTime() != null, DeviceFenceAccessRecord::getCreateTime, bo.getCreateTime());

        return lqw;
    }


    /**
     * 新增围栏进出记录
     *
     * @param bo 围栏进出记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(DeviceFenceAccessRecordBo bo) {
        DeviceFenceAccessRecord add = MapstructUtils.convert(bo, DeviceFenceAccessRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改围栏进出记录
     *
     * @param bo 围栏进出记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(DeviceFenceAccessRecordBo bo) {
        DeviceFenceAccessRecord update = MapstructUtils.convert(bo, DeviceFenceAccessRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DeviceFenceAccessRecord entity) {
        // TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除围栏进出记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            // TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
